<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - salidacoverage.info - /home/qhxar/Desktop/TPI/tpi-algoritmos-i/auxiliares.cpp</title>
  <link rel="stylesheet" type="text/css" href="../../../../../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../../../../../index.html">top level</a> - <a href="index.html">home/qhxar/Desktop/TPI/tpi-algoritmos-i</a> - auxiliares.cpp<span style="font-size: 80%;"> (source / <a href="auxiliares.cpp.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">salidacoverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">366</td>
            <td class="headerCovTableEntry">366</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2019-06-10 10:35:58</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">64</td>
            <td class="headerCovTableEntry">64</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : //</a>
<span class="lineNum">       2 </span>            : // Created by Ralo on 14/04/2019.
<span class="lineNum">       3 </span>            : //
<span class="lineNum">       4 </span>            : #include &quot;definiciones.h&quot;
<span class="lineNum">       5 </span>            : #include &quot;auxiliares.h&quot;
<span class="lineNum">       6 </span>            : 
<a name="7"><span class="lineNum">       7 </span>            : /*Auxiliares del proc 1*/</a>
<span class="lineNum">       8 </span>            : 
<span class="lineNum">       9 </span><span class="lineCov">         23 : bool esValida(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">      10 </span><span class="lineCov">         88 :     bool estructura = !vacia(ti) &amp;&amp; !vacia(th) &amp;&amp; esMatriz(ti) &amp;&amp; esMatriz(th) &amp;&amp; cantidadCorrectaDeColumnasI(ti) &amp;&amp;</span>
<span class="lineNum">      11 </span><span class="lineCov">         65 :                       cantidadCorrectaDeColumnasH(th);</span>
<span class="lineNum">      12 </span><span class="lineCov">         86 :     bool entradas = !hayIndividuosSinHogares(ti, th) &amp;&amp; !hayHogaresSinIndividuos(ti, th) &amp;&amp; !hayRepetidosI(ti) &amp;&amp;</span>
<span class="lineNum">      13 </span><span class="lineCov">         63 :                     !hayRepetidosH(th);</span>
<span class="lineNum">      14 </span><span class="lineCov">        148 :     bool rangos = mismoAnioYTrimestre(ti, th) &amp;&amp; menosDe21MiembrosPorHogar(th, ti) &amp;&amp; cantidadValidaDormitorios(th) &amp;&amp;</span>
<span class="lineNum">      15 </span><span class="lineCov">        145 :                   valoresEnRangoI(ti) &amp;&amp; valoresEnRangoH(th);</span>
<span class="lineNum">      16 </span><span class="lineCov">         23 :     bool res = estructura &amp;&amp; entradas &amp;&amp; rangos;</span>
<span class="lineNum">      17 </span><span class="lineCov">         23 :     return res;</span>
<a name="18"><span class="lineNum">      18 </span>            : }</a>
<span class="lineNum">      19 </span>            : 
<span class="lineNum">      20 </span><span class="lineCov">         43 : bool esMatriz(vector&lt;vector&lt;dato&gt; &gt; t) {</span>
<span class="lineNum">      21 </span><span class="lineCov">         43 :     int length = t[0].size();</span>
<span class="lineNum">      22 </span><span class="lineCov">         43 :     int i = 1;</span>
<span class="lineNum">      23 </span><span class="lineCov">        411 :     while (i &lt; t.size() &amp;&amp; t[i].size() == length) {</span>
<span class="lineNum">      24 </span><span class="lineCov">        184 :         i++;</span>
<span class="lineNum">      25 </span>            :     }
<span class="lineNum">      26 </span><span class="lineCov">         43 :     return i == t.size();</span>
<a name="27"><span class="lineNum">      27 </span>            : }</a>
<span class="lineNum">      28 </span>            : 
<span class="lineNum">      29 </span><span class="lineCov">         46 : bool vacia(vector&lt;vector&lt;dato&gt; &gt; t) {</span>
<span class="lineNum">      30 </span><span class="lineCov">         46 :     return t.size() == 0;</span>
<a name="31"><span class="lineNum">      31 </span>            : }</a>
<span class="lineNum">      32 </span>            : 
<span class="lineNum">      33 </span><span class="lineCov">         21 : bool cantidadCorrectaDeColumnasI(eph_i ti) {</span>
<span class="lineNum">      34 </span><span class="lineCov">         21 :     int i = 0;</span>
<span class="lineNum">      35 </span><span class="lineCov">        331 :     while (i &lt; ti.size() &amp;&amp; ti[i].size() == FILAS_INDIVIDUO) {</span>
<span class="lineNum">      36 </span><span class="lineCov">        155 :         i++;</span>
<span class="lineNum">      37 </span>            :     }
<span class="lineNum">      38 </span><span class="lineCov">         21 :     return i == ti.size();</span>
<a name="39"><span class="lineNum">      39 </span>            : }</a>
<span class="lineNum">      40 </span>            : 
<span class="lineNum">      41 </span><span class="lineCov">         21 : bool cantidadCorrectaDeColumnasH(eph_h th) {</span>
<span class="lineNum">      42 </span><span class="lineCov">         21 :     int i = 0;</span>
<span class="lineNum">      43 </span><span class="lineCov">        163 :     while (i &lt; th.size() &amp;&amp; th[i].size() == FILAS_HOGAR) {</span>
<span class="lineNum">      44 </span><span class="lineCov">         71 :         i++;</span>
<span class="lineNum">      45 </span>            :     }
<span class="lineNum">      46 </span><span class="lineCov">         21 :     return i == th.size();</span>
<a name="47"><span class="lineNum">      47 </span>            : }</a>
<span class="lineNum">      48 </span>            : 
<span class="lineNum">      49 </span><span class="lineCov">        158 : bool hayHogarConCodigo(eph_h th, int c) {</span>
<span class="lineNum">      50 </span><span class="lineCov">        158 :     int i = 0;</span>
<span class="lineNum">      51 </span><span class="lineCov">        970 :     while (i &lt; th.size() &amp;&amp; th[i][HOGCODUSU] != c) {</span>
<span class="lineNum">      52 </span><span class="lineCov">        406 :         i++;</span>
<span class="lineNum">      53 </span>            :     }
<span class="lineNum">      54 </span><span class="lineCov">        158 :     return i &lt; th.size();</span>
<a name="55"><span class="lineNum">      55 </span>            : }</a>
<span class="lineNum">      56 </span>            : 
<span class="lineNum">      57 </span><span class="lineCov">         23 : bool hayIndividuosSinHogares(eph_i ti, eph_h th) {</span>
<span class="lineNum">      58 </span><span class="lineCov">         23 :     int i = 0;</span>
<span class="lineNum">      59 </span><span class="lineCov">        337 :     while (i &lt; ti.size() &amp;&amp; hayHogarConCodigo(th, ti[i][INDCODUSU])) {</span>
<span class="lineNum">      60 </span><span class="lineCov">        157 :         i++;</span>
<span class="lineNum">      61 </span>            :     }
<span class="lineNum">      62 </span><span class="lineCov">         23 :     return i &lt; ti.size();</span>
<a name="63"><span class="lineNum">      63 </span>            : }</a>
<span class="lineNum">      64 </span>            : 
<span class="lineNum">      65 </span><span class="lineCov">         72 : bool hayIndividuoConCodigo(eph_i ti, int c) {</span>
<span class="lineNum">      66 </span><span class="lineCov">         72 :     int i = 0;</span>
<span class="lineNum">      67 </span><span class="lineCov">        882 :     while (i &lt; ti.size() &amp;&amp; ti[i][INDCODUSU] != c) {</span>
<span class="lineNum">      68 </span><span class="lineCov">        405 :         i++;</span>
<span class="lineNum">      69 </span>            :     }
<span class="lineNum">      70 </span><span class="lineCov">         72 :     return i &lt; ti.size();</span>
<a name="71"><span class="lineNum">      71 </span>            : }</a>
<span class="lineNum">      72 </span>            : 
<span class="lineNum">      73 </span><span class="lineCov">         22 : bool hayHogaresSinIndividuos(eph_i ti, eph_h th) {</span>
<span class="lineNum">      74 </span><span class="lineCov">         22 :     int i = 0;</span>
<span class="lineNum">      75 </span><span class="lineCov">        164 :     while (i &lt; th.size() &amp;&amp; hayIndividuoConCodigo(ti, th[i][HOGCODUSU])) {</span>
<span class="lineNum">      76 </span><span class="lineCov">         71 :         i++;</span>
<span class="lineNum">      77 </span>            :     }
<span class="lineNum">      78 </span><span class="lineCov">         22 :     return i &lt; th.size();</span>
<a name="79"><span class="lineNum">      79 </span>            : }</a>
<span class="lineNum">      80 </span>            : 
<span class="lineNum">      81 </span><span class="lineCov">         21 : bool hayRepetidosI(eph_i ti) {</span>
<span class="lineNum">      82 </span><span class="lineCov">         21 :     int i = 0;</span>
<span class="lineNum">      83 </span><span class="lineCov">         21 :     int j = 1;</span>
<span class="lineNum">      84 </span><span class="lineCov">        331 :     while (i &lt; ti.size() &amp;&amp; j == i + 1) {</span>
<span class="lineNum">      85 </span><span class="lineCov">       3039 :         while (j &lt; ti.size() &amp;&amp; !mismoCodusuYComponente(ti[i], ti[j])) {</span>
<span class="lineNum">      86 </span><span class="lineCov">       1442 :             j++;</span>
<span class="lineNum">      87 </span>            :         }
<span class="lineNum">      88 </span><span class="lineCov">        155 :         i++;</span>
<span class="lineNum">      89 </span><span class="lineCov">        155 :         if (j == ti.size()) { //si j llegó al final de la tabla sin encontrar repetidos, se reinicia el contador</span>
<span class="lineNum">      90 </span><span class="lineCov">        154 :             j = i + 1;</span>
<span class="lineNum">      91 </span>            :         }
<span class="lineNum">      92 </span>            :     }
<span class="lineNum">      93 </span><span class="lineCov">         21 :     return i &lt; ti.size();</span>
<a name="94"><span class="lineNum">      94 </span>            : }</a>
<span class="lineNum">      95 </span>            : 
<span class="lineNum">      96 </span><span class="lineCov">       1443 : bool mismoCodusuYComponente(individuo i1, individuo i2) {</span>
<span class="lineNum">      97 </span><span class="lineCov">       1443 :     return i1[INDCODUSU] == i2[INDCODUSU] &amp;&amp; i1[COMPONENTE] == i2[COMPONENTE];</span>
<a name="98"><span class="lineNum">      98 </span>            : }</a>
<span class="lineNum">      99 </span>            : 
<span class="lineNum">     100 </span><span class="lineCov">         20 : bool hayRepetidosH(eph_h th) {</span>
<span class="lineNum">     101 </span><span class="lineCov">         20 :     int i = 0;</span>
<span class="lineNum">     102 </span><span class="lineCov">         20 :     int j = 1;</span>
<span class="lineNum">     103 </span><span class="lineCov">        156 :     while (i &lt; th.size() &amp;&amp; j == i + 1) {</span>
<span class="lineNum">     104 </span><span class="lineCov">        416 :         while (j &lt; th.size() &amp;&amp; th[i][HOGCODUSU] != th[j][HOGCODUSU]) {</span>
<span class="lineNum">     105 </span><span class="lineCov">        174 :             j++;</span>
<span class="lineNum">     106 </span>            :         }
<span class="lineNum">     107 </span><span class="lineCov">         68 :         i++;</span>
<span class="lineNum">     108 </span><span class="lineCov">         68 :         if (j == th.size()) { //si j llegó al final de la tabla sin encontrar repetidos, se reinicia el contador</span>
<span class="lineNum">     109 </span><span class="lineCov">         67 :             j = i + 1;</span>
<span class="lineNum">     110 </span>            :         }
<span class="lineNum">     111 </span>            :     }
<span class="lineNum">     112 </span><span class="lineCov">         20 :     return i &lt; th.size();</span>
<a name="113"><span class="lineNum">     113 </span>            : }</a>
<span class="lineNum">     114 </span>            : 
<span class="lineNum">     115 </span><span class="lineCov">         23 : bool mismoAnioYTrimestre(eph_i ti, eph_h th) {</span>
<span class="lineNum">     116 </span><span class="lineCov">         23 :     int anio = ti[0][INDANIO];</span>
<span class="lineNum">     117 </span><span class="lineCov">         23 :     int trimestre = ti[0][INDTRIMESTRE];</span>
<span class="lineNum">     118 </span><span class="lineCov">         23 :     int i = 0;</span>
<span class="lineNum">     119 </span><span class="lineCov">        349 :     while (i &lt; ti.size() &amp;&amp; ti[i][INDANIO] == anio &amp;&amp; ti[i][INDTRIMESTRE] == trimestre) {</span>
<span class="lineNum">     120 </span><span class="lineCov">        163 :         i++;</span>
<span class="lineNum">     121 </span>            :     }
<span class="lineNum">     122 </span><span class="lineCov">         23 :     int j = 0;</span>
<span class="lineNum">     123 </span><span class="lineCov">        157 :     while (j &lt; th.size() &amp;&amp; th[j][HOGANIO] == anio &amp;&amp; th[j][HOGTRIMESTRE] == trimestre) {</span>
<span class="lineNum">     124 </span><span class="lineCov">         67 :         j++;</span>
<span class="lineNum">     125 </span>            :     }
<span class="lineNum">     126 </span><span class="lineCov">         23 :     return i == ti.size() &amp;&amp; j == th.size();</span>
<a name="127"><span class="lineNum">     127 </span>            : }</a>
<span class="lineNum">     128 </span>            : 
<span class="lineNum">     129 </span><span class="lineCov">         20 : bool menosDe21MiembrosPorHogar(eph_h th, eph_i ti) {</span>
<span class="lineNum">     130 </span><span class="lineCov">         20 :     int i = 0;</span>
<span class="lineNum">     131 </span><span class="lineCov">        152 :     while (i &lt; th.size() &amp;&amp; cantHabitantes(th[i], ti) &lt; 21) {</span>
<span class="lineNum">     132 </span><span class="lineCov">         66 :         i++;</span>
<span class="lineNum">     133 </span>            :     }
<span class="lineNum">     134 </span><span class="lineCov">         20 :     return i == th.size();</span>
<a name="135"><span class="lineNum">     135 </span>            : }</a>
<span class="lineNum">     136 </span>            : 
<span class="lineNum">     137 </span><span class="lineCov">        198 : int cantHabitantes(hogar h, eph_i ti) {</span>
<span class="lineNum">     138 </span><span class="lineCov">        198 :     int res = 0;</span>
<span class="lineNum">     139 </span><span class="lineCov">       2443 :     for (int i = 0; i &lt; ti.size(); i++) {</span>
<span class="lineNum">     140 </span><span class="lineCov">       2245 :         if (esSuHogar(h, ti[i])) {</span>
<span class="lineNum">     141 </span><span class="lineCov">        435 :             res++;</span>
<span class="lineNum">     142 </span>            :         }
<span class="lineNum">     143 </span>            :     }
<span class="lineNum">     144 </span><span class="lineCov">        198 :     return res;</span>
<a name="145"><span class="lineNum">     145 </span>            : }</a>
<span class="lineNum">     146 </span>            : 
<span class="lineNum">     147 </span><span class="lineCov">    5329570 : bool esSuHogar(hogar h, individuo i) {</span>
<span class="lineNum">     148 </span><span class="lineCov">    5329570 :     return h[HOGCODUSU] == i[INDCODUSU];</span>
<a name="149"><span class="lineNum">     149 </span>            : }</a>
<span class="lineNum">     150 </span>            : 
<span class="lineNum">     151 </span><span class="lineCov">         19 : bool cantidadValidaDormitorios(eph_h th) {</span>
<span class="lineNum">     152 </span><span class="lineCov">         19 :     int i = 0;</span>
<span class="lineNum">     153 </span><span class="lineCov">        149 :     while (i &lt; th.size() &amp;&amp; th[i][IV2] &gt;= th[i][II2]) {</span>
<span class="lineNum">     154 </span><span class="lineCov">         65 :         i++;</span>
<span class="lineNum">     155 </span>            :     }
<span class="lineNum">     156 </span><span class="lineCov">         19 :     return i == th.size();</span>
<a name="157"><span class="lineNum">     157 </span>            : }</a>
<span class="lineNum">     158 </span>            : 
<span class="lineNum">     159 </span><span class="lineCov">         18 : bool valoresEnRangoI(eph_i ti) {</span>
<span class="lineNum">     160 </span><span class="lineCov">         18 :     int i = 0;</span>
<span class="lineNum">     161 </span><span class="lineCov">        286 :     while (i &lt; ti.size() &amp;&amp; individuoValido(ti[i])) {</span>
<span class="lineNum">     162 </span><span class="lineCov">        134 :         i++;</span>
<span class="lineNum">     163 </span>            :     }
<span class="lineNum">     164 </span><span class="lineCov">         18 :     return i == ti.size();</span>
<a name="165"><span class="lineNum">     165 </span>            : }</a>
<span class="lineNum">     166 </span>            : 
<span class="lineNum">     167 </span><span class="lineCov">        135 : bool individuoValido(individuo i) {</span>
<span class="lineNum">     168 </span><span class="lineCov">        135 :     bool infgeneral = i[INDCODUSU] &gt; 0 &amp;&amp; i[COMPONENTE] &gt; 0 &amp;&amp; (i[INDTRIMESTRE] &gt; 0 &amp;&amp; i[INDTRIMESTRE] &lt;= 4);</span>
<span class="lineNum">     169 </span><span class="lineCov">        135 :     bool infpersonal = (i[CH4] == 1 || i[CH4] == 2) &amp;&amp; (i[CH6] &gt;= 0) &amp;&amp; (i[NIVEL_ED] == 0 || i[NIVEL_ED] == 1);</span>
<span class="lineNum">     170 </span><span class="lineCov">        405 :     bool inflaboral = (-1 &lt;= i[ESTADO] &amp;&amp; i[ESTADO] &lt;= 1) &amp;&amp; (i[CAT_OCUP] &gt;= 0 &amp;&amp; i[CAT_OCUP] &lt;= 4) &amp;&amp;</span>
<span class="lineNum">     171 </span><span class="lineCov">        558 :                       (i[p47T] &gt;= 0 || i[p47T] == -1) &amp;&amp;</span>
<span class="lineNum">     172 </span><span class="lineCov">        405 :                       (i[PP04G] &gt; 0 &amp;&amp; i[PP04G] &lt;= 10);</span>
<span class="lineNum">     173 </span><span class="lineCov">        135 :     bool res = infgeneral &amp;&amp; infpersonal &amp;&amp; inflaboral;</span>
<span class="lineNum">     174 </span><span class="lineCov">        135 :     return res;</span>
<a name="175"><span class="lineNum">     175 </span>            : }</a>
<span class="lineNum">     176 </span>            : 
<span class="lineNum">     177 </span><span class="lineCov">         17 : bool valoresEnRangoH(eph_h th) {</span>
<span class="lineNum">     178 </span><span class="lineCov">         17 :     int i = 0;</span>
<span class="lineNum">     179 </span><span class="lineCov">        145 :     while (i &lt; th.size() &amp;&amp; hogarValido(th[i])) {</span>
<span class="lineNum">     180 </span><span class="lineCov">         64 :         i++;</span>
<span class="lineNum">     181 </span>            :     }
<span class="lineNum">     182 </span><span class="lineCov">         17 :     return i == th.size();</span>
<a name="183"><span class="lineNum">     183 </span>            : }</a>
<span class="lineNum">     184 </span>            : 
<span class="lineNum">     185 </span><span class="lineCov">         64 : bool hogarValido(hogar h) {</span>
<span class="lineNum">     186 </span>            :     bool infgeneral =
<span class="lineNum">     187 </span><span class="lineCov">        192 :             h[HOGCODUSU] &gt; 0 &amp;&amp; (h[HOGTRIMESTRE] &gt; 0 &amp;&amp; h[HOGTRIMESTRE] &lt;= 4) &amp;&amp; (h[II7] &gt; 0 &amp;&amp; h[II7] &lt;= 3) &amp;&amp;</span>
<span class="lineNum">     188 </span><span class="lineCov">        192 :             (h[REGION] &gt; 0 &amp;&amp; h[REGION] &lt;= 6);</span>
<span class="lineNum">     189 </span>            :     bool infdemograf =
<span class="lineNum">     190 </span><span class="lineCov">        192 :             (h[MAS_500] == 0 || h[MAS_500] == 1) &amp;&amp; (h[IV1] &gt; 0 &amp;&amp; h[IV1] &lt;= 5) &amp;&amp; h[IV2] &gt; 0 &amp;&amp; h[II2] &gt; 0 &amp;&amp;</span>
<span class="lineNum">     191 </span><span class="lineCov">        191 :             (h[II3] == 1 || h[II3] == 2);</span>
<span class="lineNum">     192 </span><span class="lineCov">         64 :     bool res = infgeneral &amp;&amp; infdemograf;</span>
<span class="lineNum">     193 </span><span class="lineCov">         64 :     return res;</span>
<span class="lineNum">     194 </span>            : }
<span class="lineNum">     195 </span>            : 
<span class="lineNum">     196 </span>            : 
<a name="197"><span class="lineNum">     197 </span>            : /*Auxiliares del proc 2*/</a>
<span class="lineNum">     198 </span>            : 
<span class="lineNum">     199 </span><span class="lineCov">     219008 : bool esCasa(hogar h) {</span>
<span class="lineNum">     200 </span><span class="lineCov">     219008 :     return h[IV1] == 1;</span>
<a name="201"><span class="lineNum">     201 </span>            : }</a>
<span class="lineNum">     202 </span>            : 
<span class="lineNum">     203 </span><span class="lineCov">         23 : int cantHogaresCasaConNHabitaciones(eph_h &amp;th, int region, int hab) {</span>
<span class="lineNum">     204 </span><span class="lineCov">         23 :     int sum = 0;</span>
<span class="lineNum">     205 </span><span class="lineCov">         23 :     int i = 0;</span>
<span class="lineNum">     206 </span><span class="lineCov">     400547 :     while (i &lt; th.size()) {</span>
<span class="lineNum">     207 </span><span class="lineCov">     200262 :         if (esCasa(th[i]) &amp;&amp; th[i][IV2] == hab &amp;&amp; th[i][REGION] == region) {</span>
<span class="lineNum">     208 </span><span class="lineCov">       1996 :             sum++;</span>
<span class="lineNum">     209 </span>            :         }
<span class="lineNum">     210 </span><span class="lineCov">     200262 :         i++;</span>
<span class="lineNum">     211 </span>            :     }
<span class="lineNum">     212 </span><span class="lineCov">         23 :     return sum;</span>
<span class="lineNum">     213 </span>            : }
<a name="214"><span class="lineNum">     214 </span>            : /*Cuenta la cantidad de hogares con un número dado de habitaciones*/</a>
<span class="lineNum">     215 </span>            : 
<span class="lineNum">     216 </span><span class="lineCov">          4 : int cantMaxHabitacionesEnHogEnReg(eph_h &amp;th, int reg) {</span>
<span class="lineNum">     217 </span><span class="lineCov">          4 :     int i = 0;</span>
<span class="lineNum">     218 </span><span class="lineCov">          4 :     int res = 1;</span>
<span class="lineNum">     219 </span><span class="lineCov">      36528 :     while (i &lt; th.size()) {</span>
<span class="lineNum">     220 </span><span class="lineCov">      18262 :         if (esCasa(th[i]) &amp;&amp; res &lt; th[i][IV2] &amp;&amp; th[i][REGION] == reg) {</span>
<span class="lineNum">     221 </span><span class="lineCov">         12 :             res = th[i][IV2];</span>
<span class="lineNum">     222 </span>            :         }
<span class="lineNum">     223 </span><span class="lineCov">      18262 :         i++;</span>
<span class="lineNum">     224 </span>            :     }
<span class="lineNum">     225 </span><span class="lineCov">          4 :     return res;</span>
<span class="lineNum">     226 </span>            : }
<span class="lineNum">     227 </span>            : /*Dada la tabla y una región, devuelve la cantidad máxima de habitaciones en hogares que se encuentran en dicah región*/
<span class="lineNum">     228 </span>            : 
<a name="229"><span class="lineNum">     229 </span>            : /*Auxiliares del proc 3*/</a>
<span class="lineNum">     230 </span>            : 
<span class="lineNum">     231 </span><span class="lineCov">        484 : bool esHogarValido(hogar h, int region) {</span>
<span class="lineNum">     232 </span><span class="lineCov">        484 :     return esCasa(h) &amp;&amp; h[REGION] == region &amp;&amp; h[MAS_500] == 0;</span>
<a name="233"><span class="lineNum">     233 </span>            : }</a>
<span class="lineNum">     234 </span>            : 
<span class="lineNum">     235 </span><span class="lineCov">         31 : int cantHogaresValidos(eph_h th, int region) {</span>
<span class="lineNum">     236 </span><span class="lineCov">         31 :     int res = 0;</span>
<span class="lineNum">     237 </span><span class="lineCov">        417 :     for (int i = 0; i &lt; th.size(); i++) {</span>
<span class="lineNum">     238 </span><span class="lineCov">        386 :         if (esHogarValido(th[i], region)) {</span>
<span class="lineNum">     239 </span><span class="lineCov">         28 :             res++;</span>
<span class="lineNum">     240 </span>            :         }
<span class="lineNum">     241 </span>            :     }
<span class="lineNum">     242 </span><span class="lineCov">         31 :     return res;</span>
<a name="243"><span class="lineNum">     243 </span>            : }</a>
<span class="lineNum">     244 </span>            : 
<span class="lineNum">     245 </span><span class="lineCov">         14 : bool hogarConHacinamientoCritico(hogar h, eph_i &amp;ti) {</span>
<span class="lineNum">     246 </span><span class="lineCov">         14 :     return cantHabitantes(h, ti) &gt; 3 * h[II2];</span>
<a name="247"><span class="lineNum">     247 </span>            : }</a>
<span class="lineNum">     248 </span>            : 
<span class="lineNum">     249 </span><span class="lineCov">          7 : int cantHogaresValidosConHC(eph_h th, eph_i &amp;ti, int region) {</span>
<span class="lineNum">     250 </span><span class="lineCov">          7 :     int res = 0;</span>
<span class="lineNum">     251 </span><span class="lineCov">        105 :     for (int i = 0; i &lt; th.size(); i++) {</span>
<span class="lineNum">     252 </span><span class="lineCov">         98 :         if (esHogarValido(th[i], region) &amp;&amp; hogarConHacinamientoCritico(th[i], ti)) {</span>
<span class="lineNum">     253 </span><span class="lineCov">          7 :             res++;</span>
<span class="lineNum">     254 </span>            :         }
<span class="lineNum">     255 </span>            :     }
<span class="lineNum">     256 </span><span class="lineCov">          7 :     return res;</span>
<a name="257"><span class="lineNum">     257 </span>            : }</a>
<span class="lineNum">     258 </span>            : 
<span class="lineNum">     259 </span><span class="lineCov">         24 : float proporcionDeCasasConHC(eph_h &amp;th, eph_i &amp;ti, int region) {</span>
<span class="lineNum">     260 </span><span class="lineCov">         24 :     float res = 0;</span>
<span class="lineNum">     261 </span><span class="lineCov">         24 :     if (cantHogaresValidos(th, region) &gt; 0) {</span>
<span class="lineNum">     262 </span><span class="lineCov">          7 :         res = ((float) cantHogaresValidosConHC(th, ti, region) / cantHogaresValidos(th, region));</span>
<span class="lineNum">     263 </span>            :     }
<span class="lineNum">     264 </span><span class="lineCov">         24 :     return res;</span>
<span class="lineNum">     265 </span>            : }
<span class="lineNum">     266 </span>            : 
<span class="lineNum">     267 </span>            : 
<a name="268"><span class="lineNum">     268 </span>            : /*Auxiliares del proc 4*/</a>
<span class="lineNum">     269 </span>            : 
<span class="lineNum">     270 </span><span class="lineCov">      18906 : bool trabaja(individuo i) {</span>
<span class="lineNum">     271 </span><span class="lineCov">      18906 :     return i[ESTADO] == OCUPADO;</span>
<a name="272"><span class="lineNum">     272 </span>            : }</a>
<span class="lineNum">     273 </span>            : 
<span class="lineNum">     274 </span><span class="lineCov">       5254 : bool esDeCiudadGrande(individuo i, eph_h th) {</span>
<span class="lineNum">     275 </span><span class="lineCov">       5254 :     int j = 0;</span>
<span class="lineNum">     276 </span><span class="lineCov">    8006118 :     while (j &lt; th.size() &amp;&amp; (!esSuHogar(th[j], i) || th[j][MAS_500] == 0)) {</span>
<span class="lineNum">     277 </span><span class="lineCov">    4000432 :         j++;</span>
<span class="lineNum">     278 </span>            :     }
<span class="lineNum">     279 </span><span class="lineCov">       5254 :     return j &lt; th.size();</span>
<a name="280"><span class="lineNum">     280 </span>            : }</a>
<span class="lineNum">     281 </span>            : 
<span class="lineNum">     282 </span><span class="lineCov">       2443 : bool esCasaODepartamento(hogar h) {</span>
<span class="lineNum">     283 </span><span class="lineCov">       2443 :     return h[IV1] == CASA || h[IV1] == 2; //No está incluida la definición DEPARTAMENTO = 2 en definiciones.h</span>
<a name="284"><span class="lineNum">     284 </span>            : }</a>
<span class="lineNum">     285 </span>            : 
<span class="lineNum">     286 </span><span class="lineCov">       2617 : bool realizaSusTareasEnEsteHogar(individuo i) {</span>
<span class="lineNum">     287 </span><span class="lineCov">       2617 :     return i[PP04G] == EN_ESTE_HOGAR;</span>
<a name="288"><span class="lineNum">     288 </span>            : }</a>
<span class="lineNum">     289 </span>            : 
<span class="lineNum">     290 </span><span class="lineCov">        125 : bool tieneEspaciosReservadosParaElTrabajo(hogar h) {</span>
<span class="lineNum">     291 </span><span class="lineCov">        125 :     return h[II3] == 1;</span>
<a name="292"><span class="lineNum">     292 </span>            : }</a>
<span class="lineNum">     293 </span>            : 
<span class="lineNum">     294 </span><span class="lineCov">       2443 : bool suHogarEsCasaODepartamento(individuo i, eph_h th) {</span>
<span class="lineNum">     295 </span><span class="lineCov">       2443 :     int j = 0;</span>
<span class="lineNum">     296 </span><span class="lineCov">    2426795 :     while (j &lt; th.size() &amp;&amp; (!esSuHogar(th[j], i) || !esCasaODepartamento(th[j]))) {</span>
<span class="lineNum">     297 </span><span class="lineCov">    1212176 :         j++;</span>
<span class="lineNum">     298 </span>            :     }
<span class="lineNum">     299 </span><span class="lineCov">       2443 :     return j &lt; th.size();</span>
<a name="300"><span class="lineNum">     300 </span>            : }</a>
<span class="lineNum">     301 </span>            : 
<span class="lineNum">     302 </span><span class="lineCov">        125 : bool suHogarTieneEspaciosReservadosParaElTrabajo(individuo i, eph_h &amp;th) {</span>
<span class="lineNum">     303 </span><span class="lineCov">        125 :     int j = 0;</span>
<span class="lineNum">     304 </span><span class="lineCov">     219807 :     while (j &lt; th.size() &amp;&amp; (!esSuHogar(th[j], i) || !tieneEspaciosReservadosParaElTrabajo(th[j]))) {</span>
<span class="lineNum">     305 </span><span class="lineCov">     109841 :         j++;</span>
<span class="lineNum">     306 </span>            :     }
<span class="lineNum">     307 </span><span class="lineCov">        125 :     return j &lt; th.size();</span>
<a name="308"><span class="lineNum">     308 </span>            : }</a>
<span class="lineNum">     309 </span>            : 
<span class="lineNum">     310 </span><span class="lineCov">       5254 : bool individuoEnHogarValido(individuo i, eph_h th) {</span>
<span class="lineNum">     311 </span><span class="lineCov">       5254 :     return esDeCiudadGrande(i, th) &amp;&amp; suHogarEsCasaODepartamento(i, th);</span>
<a name="312"><span class="lineNum">     312 </span>            : }</a>
<span class="lineNum">     313 </span>            : 
<span class="lineNum">     314 </span><span class="lineCov">       2617 : bool trabajaEnSuVivienda(individuo i, eph_h th) {</span>
<span class="lineNum">     315 </span><span class="lineCov">       2617 :     return realizaSusTareasEnEsteHogar(i) &amp;&amp; suHogarTieneEspaciosReservadosParaElTrabajo(i, th);</span>
<a name="316"><span class="lineNum">     316 </span>            : }</a>
<span class="lineNum">     317 </span>            : 
<span class="lineNum">     318 </span><span class="lineCov">         12 : int cantIndividuosQueTrabajan(eph_h th, eph_i ti) {</span>
<span class="lineNum">     319 </span><span class="lineCov">         12 :     int res = 0;</span>
<span class="lineNum">     320 </span><span class="lineCov">      12616 :     for (int i = 0; i &lt; ti.size(); i++) {</span>
<span class="lineNum">     321 </span><span class="lineCov">      12604 :         if (trabaja(ti[i]) &amp;&amp; individuoEnHogarValido(ti[i], th)) {</span>
<span class="lineNum">     322 </span><span class="lineCov">       2404 :             res++;</span>
<span class="lineNum">     323 </span>            :         }
<span class="lineNum">     324 </span>            :     }
<span class="lineNum">     325 </span><span class="lineCov">         12 :     return res;</span>
<a name="326"><span class="lineNum">     326 </span>            : }</a>
<span class="lineNum">     327 </span>            : 
<span class="lineNum">     328 </span><span class="lineCov">          6 : int cantIndividuosTrabajandoEnSuvivienda(eph_h th, eph_i ti) {</span>
<span class="lineNum">     329 </span><span class="lineCov">          6 :     int res = 0;</span>
<span class="lineNum">     330 </span><span class="lineCov">       6308 :     for (int i = 0; i &lt; ti.size(); i++) {</span>
<span class="lineNum">     331 </span><span class="lineCov">       6302 :         if (trabaja(ti[i]) &amp;&amp; trabajaEnSuVivienda(ti[i], th) &amp;&amp; individuoEnHogarValido(ti[i], th)) {</span>
<span class="lineNum">     332 </span><span class="lineCov">          9 :             res++;</span>
<span class="lineNum">     333 </span>            :         }
<span class="lineNum">     334 </span>            :     }
<span class="lineNum">     335 </span><span class="lineCov">          6 :     return res;</span>
<a name="336"><span class="lineNum">     336 </span>            : }</a>
<span class="lineNum">     337 </span>            : 
<span class="lineNum">     338 </span><span class="lineCov">          6 : float proporcionTeleworking(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">     339 </span><span class="lineCov">          6 :     float res = 0;</span>
<span class="lineNum">     340 </span><span class="lineCov">          6 :     if (cantIndividuosQueTrabajan(th, ti) &gt; 0) {</span>
<span class="lineNum">     341 </span><span class="lineCov">          6 :         res = ((float) cantIndividuosTrabajandoEnSuvivienda(th, ti) / cantIndividuosQueTrabajan(th, ti));</span>
<span class="lineNum">     342 </span>            :     }
<span class="lineNum">     343 </span><span class="lineCov">          6 :     return res;</span>
<span class="lineNum">     344 </span>            : }
<span class="lineNum">     345 </span>            : 
<span class="lineNum">     346 </span>            : 
<a name="347"><span class="lineNum">     347 </span>            : /*Auxiliares del proc 5*/</a>
<span class="lineNum">     348 </span>            : 
<span class="lineNum">     349 </span><span class="lineCov">         12 : vector&lt;vector&lt;int&gt;&gt; auxOrdenarPorRegion(eph_h th) {</span>
<span class="lineNum">     350 </span><span class="lineCov">         12 :     int j = th.size() - 1;</span>
<span class="lineNum">     351 </span><span class="lineCov">         96 :     while (j &gt; 0) {</span>
<span class="lineNum">     352 </span><span class="lineCov">         42 :         int i = 0;</span>
<span class="lineNum">     353 </span><span class="lineCov">        462 :         while (i &lt; j) {</span>
<span class="lineNum">     354 </span><span class="lineCov">        210 :             if (th[i][REGION] &gt; th[i + 1][REGION]) {</span>
<span class="lineNum">     355 </span><span class="lineCov">         40 :                 vector&lt;int&gt; aux = th[i + 1];</span>
<span class="lineNum">     356 </span><span class="lineCov">         20 :                 th[i + 1] = th[i];</span>
<span class="lineNum">     357 </span><span class="lineCov">         20 :                 th[i] = aux;</span>
<span class="lineNum">     358 </span>            :             }
<span class="lineNum">     359 </span><span class="lineCov">        210 :             i++;</span>
<span class="lineNum">     360 </span>            :         }
<span class="lineNum">     361 </span><span class="lineCov">         42 :         j--;</span>
<span class="lineNum">     362 </span>            :     }
<span class="lineNum">     363 </span><span class="lineCov">         12 :     return th;</span>
<span class="lineNum">     364 </span>            : }
<a name="365"><span class="lineNum">     365 </span>            : /*Ordena la tabla de hogares por región*/</a>
<span class="lineNum">     366 </span>            : 
<span class="lineNum">     367 </span><span class="lineCov">          8 : vector&lt;vector&lt;int&gt;&gt; auxOrdenarPorCodusuEnRegion(eph_h th) {</span>
<span class="lineNum">     368 </span><span class="lineCov">          8 :     th = auxOrdenarPorRegion(th);</span>
<span class="lineNum">     369 </span><span class="lineCov">          8 :     int k = 1;</span>
<span class="lineNum">     370 </span><span class="lineCov">        104 :     while (k &lt; 7) {</span>
<span class="lineNum">     371 </span><span class="lineCov">         48 :         int j = th.size() - 1;</span>
<span class="lineNum">     372 </span><span class="lineCov">        384 :         while (j &gt; 0) {</span>
<span class="lineNum">     373 </span><span class="lineCov">        168 :             int i = 0;</span>
<span class="lineNum">     374 </span><span class="lineCov">       1848 :             while (i &lt; j) {</span>
<span class="lineNum">     375 </span><span class="lineCov">        840 :                 if (th[i][HOGCODUSU] &gt; th[i + 1][HOGCODUSU] &amp;&amp; th[i][REGION] == k &amp;&amp; th[i + 1][REGION] == k) {</span>
<span class="lineNum">     376 </span><span class="lineCov">          4 :                     vector&lt;int&gt; aux = th[i + 1];</span>
<span class="lineNum">     377 </span><span class="lineCov">          2 :                     th[i + 1] = th[i];</span>
<span class="lineNum">     378 </span><span class="lineCov">          2 :                     th[i] = aux;</span>
<span class="lineNum">     379 </span>            :                 }
<span class="lineNum">     380 </span><span class="lineCov">        840 :                 i++;</span>
<span class="lineNum">     381 </span>            :             }
<span class="lineNum">     382 </span><span class="lineCov">        168 :             j--;</span>
<span class="lineNum">     383 </span>            :         }
<span class="lineNum">     384 </span><span class="lineCov">         48 :         k++;</span>
<span class="lineNum">     385 </span>            :     }
<span class="lineNum">     386 </span><span class="lineCov">          8 :     return th;</span>
<span class="lineNum">     387 </span>            : }
<a name="388"><span class="lineNum">     388 </span>            : /*Ordena por hogcodusu dentro de cada bloque de región. Trabaja con la tabla ya ordenada por región*/</a>
<span class="lineNum">     389 </span>            : 
<span class="lineNum">     390 </span><span class="lineCov">          4 : vector&lt;vector&lt;int&gt;&gt; auxOrdenarPorCodusuIndividuos(eph_h th, eph_i ti) {</span>
<span class="lineNum">     391 </span><span class="lineCov">          4 :     th = auxOrdenarPorCodusuEnRegion(auxOrdenarPorRegion(th));</span>
<span class="lineNum">     392 </span><span class="lineCov">          4 :     int i = 0;</span>
<span class="lineNum">     393 </span><span class="lineCov">          8 :     vector&lt;vector&lt;int&gt;&gt; aux;</span>
<span class="lineNum">     394 </span><span class="lineCov">         40 :     while (i &lt; th.size()) {</span>
<span class="lineNum">     395 </span><span class="lineCov">         18 :         int j = 0;</span>
<span class="lineNum">     396 </span><span class="lineCov">        360 :         while (j &lt; ti.size()) {</span>
<span class="lineNum">     397 </span><span class="lineCov">        171 :             if (th[i][HOGCODUSU] == ti[j][INDCODUSU]) {</span>
<span class="lineNum">     398 </span><span class="lineCov">         26 :                 aux.push_back(ti[j]);</span>
<span class="lineNum">     399 </span>            :             }
<span class="lineNum">     400 </span><span class="lineCov">        171 :             j++;</span>
<span class="lineNum">     401 </span>            :         }
<span class="lineNum">     402 </span><span class="lineCov">         18 :         i++;</span>
<span class="lineNum">     403 </span>            :     }
<span class="lineNum">     404 </span><span class="lineCov">          4 :     ti = aux;</span>
<span class="lineNum">     405 </span><span class="lineCov">          8 :     return ti;</span>
<span class="lineNum">     406 </span>            : }
<a name="407"><span class="lineNum">     407 </span>            : /*Ordena la tabla de individuos de acuerdo a la posición de los hogcodusu en la tabla de hogares*/</a>
<span class="lineNum">     408 </span>            : 
<span class="lineNum">     409 </span><span class="lineCov">         56 : int finDeBloque(int n, eph_i ti) {</span>
<span class="lineNum">     410 </span><span class="lineCov">         56 :     int i = n;</span>
<span class="lineNum">     411 </span><span class="lineCov">        280 :     while (i &lt; ti.size() &amp;&amp; ti[n][INDCODUSU] == ti[i][INDCODUSU]) {</span>
<span class="lineNum">     412 </span><span class="lineCov">        112 :         i++;</span>
<span class="lineNum">     413 </span>            :     }
<span class="lineNum">     414 </span><span class="lineCov">         56 :     return i - 1;</span>
<span class="lineNum">     415 </span>            : }
<span class="lineNum">     416 </span>            :   /*Esta función se fija el incodusu en la posición n. Luego, se fija hasta qué posición comparten dicho indcodusu,*/
<a name="417"><span class="lineNum">     417 </span>            :   /*y devuelve el último, marcando de dónde a dónde los individuos comparten el hogar*/</a>
<span class="lineNum">     418 </span>            : 
<span class="lineNum">     419 </span><span class="lineCov">          4 : vector&lt;vector&lt;int&gt;&gt; auxOrdenarPorComponenteAIndividuos(eph_h &amp;th, eph_i ti) {</span>
<span class="lineNum">     420 </span><span class="lineCov">          4 :     ti = auxOrdenarPorCodusuIndividuos(th, ti);</span>
<span class="lineNum">     421 </span><span class="lineCov">          4 :     int i = 0;</span>
<span class="lineNum">     422 </span><span class="lineCov">         34 :     while (i &lt; ti.size()) {</span>
<span class="lineNum">     423 </span><span class="lineCov">         15 :         int j = i;</span>
<span class="lineNum">     424 </span><span class="lineCov">         67 :         while (j &lt;= finDeBloque(i, ti)) {</span>
<span class="lineNum">     425 </span><span class="lineCov">         26 :             int k = j;</span>
<span class="lineNum">     426 </span><span class="lineCov">        112 :             while (k &gt;= i) {</span>
<span class="lineNum">     427 </span><span class="lineCov">         43 :                 int l = i;</span>
<span class="lineNum">     428 </span><span class="lineCov">         91 :                 while (l &lt; k) {</span>
<span class="lineNum">     429 </span><span class="lineCov">         24 :                     if (ti[l][COMPONENTE] &gt; ti[l + 1][COMPONENTE]) {</span>
<span class="lineNum">     430 </span><span class="lineCov">         22 :                         vector&lt;int&gt; aux = ti[l + 1];</span>
<span class="lineNum">     431 </span><span class="lineCov">         11 :                         ti[l + 1] = ti[l];</span>
<span class="lineNum">     432 </span><span class="lineCov">         11 :                         ti[l] = aux;</span>
<span class="lineNum">     433 </span>            :                     }
<span class="lineNum">     434 </span><span class="lineCov">         24 :                     l++;</span>
<span class="lineNum">     435 </span>            :                 }
<span class="lineNum">     436 </span><span class="lineCov">         43 :                 k--;</span>
<span class="lineNum">     437 </span>            :             }
<span class="lineNum">     438 </span><span class="lineCov">         26 :             j++;</span>
<span class="lineNum">     439 </span>            :         }
<span class="lineNum">     440 </span><span class="lineCov">         15 :         i = finDeBloque(i, ti) + 1;</span>
<span class="lineNum">     441 </span>            :     }
<span class="lineNum">     442 </span><span class="lineCov">          4 :     return ti;</span>
<span class="lineNum">     443 </span>            : }
<span class="lineNum">     444 </span>            : /*Una vez ordenada según codusu, ordena la tabla de individuos por componente dentro de cada bloque*/
<span class="lineNum">     445 </span>            : 
<a name="446"><span class="lineNum">     446 </span>            : /*Auxiliares del proc 6*/</a>
<span class="lineNum">     447 </span>            : 
<span class="lineNum">     448 </span><span class="lineCov">       5125 : int ingresos(hogar &amp;h, eph_i &amp;ti) {</span>
<span class="lineNum">     449 </span><span class="lineCov">       5125 :     int res = 0;</span>
<span class="lineNum">     450 </span><span class="lineCov">      95368 :     for (int i = 0; i &lt; ti.size(); i++) {</span>
<span class="lineNum">     451 </span><span class="lineCov">      90243 :         if (ti[i][INDCODUSU] == h[HOGCODUSU] &amp;&amp; ti[i][p47T] &gt; -1) {</span>
<span class="lineNum">     452 </span><span class="lineCov">       7121 :             res = res + ti[i][p47T];</span>
<span class="lineNum">     453 </span>            :         }
<span class="lineNum">     454 </span>            :     }
<span class="lineNum">     455 </span><span class="lineCov">       5125 :     return res;</span>
<a name="456"><span class="lineNum">     456 </span>            : }</a>
<span class="lineNum">     457 </span>            : 
<span class="lineNum">     458 </span><span class="lineCov">       1972 : int difIngresos(eph_i &amp;ti, hogar h1, hogar h2) {</span>
<span class="lineNum">     459 </span><span class="lineCov">       1972 :     return ingresos(h2, ti) - ingresos(h1, ti);</span>
<a name="460"><span class="lineNum">     460 </span>            : }</a>
<span class="lineNum">     461 </span>            : 
<span class="lineNum">     462 </span><span class="lineCov">        118 : /*Auxiliar para selection sort*/</span>
<span class="lineNum">     463 </span><span class="lineCov">        118 : int indiceDeHogarConIngresoMinEnSubsec(eph_h &amp;th, eph_i ti, int l, int r) {</span>
<span class="lineNum">     464 </span><span class="lineCov">        118 :     int i = r;</span>
<span class="lineNum">     465 </span><span class="lineCov">       1182 :     int res = i;</span>
<span class="lineNum">     466 </span><span class="lineCov">        532 :     while (i &gt; l) {</span>
<span class="lineNum">     467 </span><span class="lineCov">        278 :         if (ingresos(th[i - 1], ti) &lt; ingresos(th[res], ti)) {</span>
<span class="lineNum">     468 </span>            :             res = i - 1;
<span class="lineNum">     469 </span><span class="lineCov">        532 :         }</span>
<span class="lineNum">     470 </span>            :         i--;
<span class="lineNum">     471 </span><span class="lineCov">        118 :     }</span>
<a name="472"><span class="lineNum">     472 </span>            :     return res;</a>
<span class="lineNum">     473 </span>            : }
<span class="lineNum">     474 </span><span class="lineCov">          7 : </span>
<span class="lineNum">     475 </span><span class="lineCov">          7 : void ordenarTablaHogaresPorIngresos(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">     476 </span><span class="lineCov">        125 :     int i = 0;</span>
<span class="lineNum">     477 </span><span class="lineCov">        118 :     while (i &lt; th.size()) {</span>
<span class="lineNum">     478 </span><span class="lineCov">         59 :         hogar aux = th[i];</span>
<span class="lineNum">     479 </span><span class="lineCov">         59 :         th[i] = th[indiceDeHogarConIngresoMinEnSubsec(th, ti, i, th.size() - 1)];</span>
<span class="lineNum">     480 </span><span class="lineCov">         59 :         th[indiceDeHogarConIngresoMinEnSubsec(th, ti, i, th.size() - 1)] = aux;</span>
<span class="lineNum">     481 </span>            :         i++;
<span class="lineNum">     482 </span><span class="lineCov">          7 :     }</span>
<span class="lineNum">     483 </span>            : }
<a name="484"><span class="lineNum">     484 </span>            : </a>
<span class="lineNum">     485 </span>            : /*Toma la diferencia entre los hogares en las posiciones i y j y luego recorre la tabla hogares para generar una
<span class="lineNum">     486 </span><span class="lineCov">        457 : muestra homogénea con esa diferencia*/</span>
<span class="lineNum">     487 </span><span class="lineCov">        457 : vector&lt;hogar&gt; generarMuestraHomogeneaConDifEntreHogIyHogJ(eph_h th, eph_i ti, int i, int j) {</span>
<span class="lineNum">     488 </span><span class="lineCov">        457 :     vector&lt;hogar&gt; res;</span>
<span class="lineNum">     489 </span><span class="lineCov">        457 :     int dif = difIngresos(ti, th[i], th[j]);</span>
<span class="lineNum">     490 </span><span class="lineCov">        457 :     res.push_back(th[i]);</span>
<span class="lineNum">     491 </span><span class="lineCov">       1972 :     res.push_back(th[j]);</span>
<span class="lineNum">     492 </span><span class="lineCov">       1515 :     for (int k = j + 1; k &lt; th.size(); k++) {</span>
<span class="lineNum">     493 </span><span class="lineCov">        174 :         if (difIngresos(ti, res[res.size() - 1], th[k]) == dif &amp;&amp; dif &gt; 0) {</span>
<span class="lineNum">     494 </span>            :             res.push_back(th[k]);
<span class="lineNum">     495 </span>            :         }
<span class="lineNum">     496 </span><span class="lineCov">        457 :     }</span>
<span class="lineNum">     497 </span>            :     return res;
<span class="lineNum">     498 </span>            : }
<span class="lineNum">     499 </span>            : 
<a name="500"><span class="lineNum">     500 </span>            : /*A partir de una tabla hogares ordenada por ingresos, recorre todos los pares de hogares (i y j) en la tabla hogares.</a>
<span class="lineNum">     501 </span>            : Si con la diferencia de ingresos entre un hogar i y hogar j se puede generar una muestra homogénea de longitud mayor o
<span class="lineNum">     502 </span><span class="lineCov">         11 : igual a 3, la incluye en un vector que contiene todas las muestras homogéneas posibles que cumplen con lo pedido. */</span>
<span class="lineNum">     503 </span><span class="lineCov">         11 : vector&lt;vector&lt;hogar&gt; &gt; generarMuestrasHomogeneas(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">     504 </span><span class="lineCov">         11 :     vector&lt;vector&lt;hogar&gt; &gt; res;</span>
<span class="lineNum">     505 </span><span class="lineCov">         11 :     int i = 0;</span>
<span class="lineNum">     506 </span><span class="lineCov">        183 :     int j = i + 1;</span>
<span class="lineNum">     507 </span><span class="lineCov">       1000 :     while (i &lt; th.size() - 1) {</span>
<span class="lineNum">     508 </span><span class="lineCov">        914 :         while (j &lt; th.size()) {</span>
<span class="lineNum">     509 </span><span class="lineCov">        457 :             vector&lt;hogar&gt; muestraHomogeneaConDifEntreHogIyHogJ = generarMuestraHomogeneaConDifEntreHogIyHogJ(th, ti, i, j);</span>
<span class="lineNum">     510 </span><span class="lineCov">         90 :             if (muestraHomogeneaConDifEntreHogIyHogJ.size() &gt;= 3) {</span>
<span class="lineNum">     511 </span>            :                 res.push_back(muestraHomogeneaConDifEntreHogIyHogJ);
<span class="lineNum">     512 </span><span class="lineCov">        457 :             }</span>
<span class="lineNum">     513 </span>            :             j++;
<span class="lineNum">     514 </span><span class="lineCov">         86 :         }</span>
<span class="lineNum">     515 </span><span class="lineCov">         86 :         i++;</span>
<span class="lineNum">     516 </span>            :         j = i + 1;
<span class="lineNum">     517 </span><span class="lineCov">         11 :     }</span>
<a name="518"><span class="lineNum">     518 </span>            :     return res;</a>
<span class="lineNum">     519 </span>            : }
<span class="lineNum">     520 </span><span class="lineCov">          7 : </span>
<span class="lineNum">     521 </span><span class="lineCov">          7 : bool existeSolucionMuestraHomogeneaConAlMenos3(eph_h th, eph_i ti) {</span>
<a name="522"><span class="lineNum">     522 </span>            :     return generarMuestrasHomogeneas(th, ti).size() &gt; 0;</a>
<span class="lineNum">     523 </span>            : }
<span class="lineNum">     524 </span><span class="lineCov">          4 : </span>
<span class="lineNum">     525 </span><span class="lineCov">          8 : vector&lt;hogar&gt; mayorMuestraHomogenea(eph_h th, eph_i ti) {</span>
<span class="lineNum">     526 </span><span class="lineCov">          4 :     vector&lt;vector&lt;hogar&gt; &gt; muestrasHomogeneas = generarMuestrasHomogeneas(th, ti);</span>
<span class="lineNum">     527 </span><span class="lineCov">          4 :     vector&lt;hogar&gt; res = muestrasHomogeneas[0];</span>
<span class="lineNum">     528 </span><span class="lineCov">         86 :     int i = 1;</span>
<span class="lineNum">     529 </span><span class="lineCov">         41 :     while (i &lt; muestrasHomogeneas.size()) {</span>
<span class="lineNum">     530 </span><span class="lineCov">          2 :         if (res.size() &lt; muestrasHomogeneas[i].size()) {</span>
<span class="lineNum">     531 </span>            :             res = muestrasHomogeneas[i];
<span class="lineNum">     532 </span><span class="lineCov">         41 :         }</span>
<span class="lineNum">     533 </span>            :         i++;
<span class="lineNum">     534 </span><span class="lineCov">          8 :     }</span>
<span class="lineNum">     535 </span>            :     return res;
<span class="lineNum">     536 </span>            : }
<span class="lineNum">     537 </span>            : 
<a name="538"><span class="lineNum">     538 </span>            : </a>
<span class="lineNum">     539 </span>            : /*Auxiliares del proc 7*/
<span class="lineNum">     540 </span><span class="lineCov">          3 : </span>
<span class="lineNum">     541 </span><span class="lineCov">         20 : void modificaRegionGBAaPampeana(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">     542 </span><span class="lineCov">         17 :     for (int i = 0; i &lt; th.size(); i++) {</span>
<span class="lineNum">     543 </span><span class="lineCov">          5 :         if (th[i][REGION] == GBA) {</span>
<span class="lineNum">     544 </span>            :             th[i][REGION] = PAMPEANA;
<span class="lineNum">     545 </span>            :         }
<span class="lineNum">     546 </span><span class="lineCov">          3 :     }</span>
<span class="lineNum">     547 </span>            : }
<span class="lineNum">     548 </span>            : 
<span class="lineNum">     549 </span>            : 
<span class="lineNum">     550 </span>            : /*Auxiliares del proc 8*/
<a name="551"><span class="lineNum">     551 </span>            : </a>
<span class="lineNum">     552 </span>            : float areaIgualdadTotal = 0.5;
<span class="lineNum">     553 </span><span class="lineCov">        117 : </span>
<span class="lineNum">     554 </span><span class="lineCov">        117 : float ingresosPerCapitaEnHogar(hogar h, eph_i ti) {</span>
<a name="555"><span class="lineNum">     555 </span>            :     return ((float) ingresos(h, ti) / cantHabitantes(h, ti));</a>
<span class="lineNum">     556 </span>            : }
<span class="lineNum">     557 </span><span class="lineCov">         36 : </span>
<span class="lineNum">     558 </span><span class="lineCov">         36 : float ingresosHasta(int n, eph_h th, eph_i ti) {</span>
<span class="lineNum">     559 </span><span class="lineCov">        105 :     float res = 0;</span>
<span class="lineNum">     560 </span><span class="lineCov">         69 :     for (int i = 0; i &lt;= n; i++) {</span>
<span class="lineNum">     561 </span>            :         res = res + ingresosPerCapitaEnHogar(th[i], ti);
<span class="lineNum">     562 </span><span class="lineCov">         36 :     }</span>
<a name="563"><span class="lineNum">     563 </span>            :     return res;</a>
<span class="lineNum">     564 </span>            : }
<span class="lineNum">     565 </span><span class="lineCov">          5 : </span>
<span class="lineNum">     566 </span><span class="lineCov">          5 : float integralDeIngresosObservados(eph_h &amp;th, eph_i &amp;ti) {</span>
<span class="lineNum">     567 </span><span class="lineCov">         17 :     float res = 0;</span>
<span class="lineNum">     568 </span><span class="lineCov">         36 :     for (int i = 0; i &lt; th.size(); i++) {</span>
<span class="lineNum">     569 </span><span class="lineCov">         24 :         res = res + ingresosHasta(i - 1, th, ti) / ingresosHasta(th.size() - 1, th, ti) +</span>
<span class="lineNum">     570 </span>            :               0.5 * (ingresosPerCapitaEnHogar(th[i], ti) / ingresosHasta(th.size() - 1, th, ti));
<span class="lineNum">     571 </span><span class="lineCov">          5 :     }</span>
<a name="572"><span class="lineNum">     572 </span>            :     return res / th.size();</a>
<span class="lineNum">     573 </span>            : }
<span class="lineNum">     574 </span><span class="lineCov">          5 : </span>
<span class="lineNum">     575 </span><span class="lineCov">          5 : float areaObservada(eph_h &amp;th, eph_i &amp;ti) {</span>
<a name="576"><span class="lineNum">     576 </span>            :     return areaIgualdadTotal - integralDeIngresosObservados(th, ti);</a>
<span class="lineNum">     577 </span>            : }
<span class="lineNum">     578 </span><span class="lineCov">         24 : </span>
<span class="lineNum">     579 </span><span class="lineCov">         24 : /*Auxiliar para selection sort*/</span>
<span class="lineNum">     580 </span><span class="lineCov">         24 : int indiceDeHogConIngresoMinPerCapitaEnSubsec(eph_h &amp;th, eph_i &amp;ti, int l, int r) {</span>
<span class="lineNum">     581 </span><span class="lineCov">         60 :     int i = r;</span>
<span class="lineNum">     582 </span><span class="lineCov">         18 :     int res = i;</span>
<span class="lineNum">     583 </span><span class="lineCov">         12 :     while (i &gt; l) {</span>
<span class="lineNum">     584 </span>            :         if (ingresosPerCapitaEnHogar(th[i - 1], ti) &lt; ingresosPerCapitaEnHogar(th[res], ti)) {
<span class="lineNum">     585 </span><span class="lineCov">         18 :             res = i - 1;</span>
<span class="lineNum">     586 </span>            :         }
<span class="lineNum">     587 </span><span class="lineCov">         24 :         i--;</span>
<a name="588"><span class="lineNum">     588 </span>            :     }</a>
<span class="lineNum">     589 </span>            :     return res;
<span class="lineNum">     590 </span><span class="lineCov">          5 : }</span>
<span class="lineNum">     591 </span><span class="lineCov">          5 : </span>
<span class="lineNum">     592 </span><span class="lineCov">         29 : void ordenarTablaHogaresPorIngresosPerCapita(eph_h th, eph_i ti) {</span>
<span class="lineNum">     593 </span><span class="lineCov">         24 :     int i = 0;</span>
<span class="lineNum">     594 </span><span class="lineCov">         12 :     while (i &lt; th.size()) {</span>
<span class="lineNum">     595 </span><span class="lineCov">         12 :         hogar aux = th[i];</span>
<span class="lineNum">     596 </span><span class="lineCov">         12 :         th[i] = th[indiceDeHogConIngresoMinPerCapitaEnSubsec(th, ti, i, th.size() - 1)];</span>
<span class="lineNum">     597 </span>            :         th[indiceDeHogConIngresoMinPerCapitaEnSubsec(th, ti, i, th.size() - 1)] = aux;
<a name="598"><span class="lineNum">     598 </span><span class="lineCov">          5 :         i++;</span></a>
<span class="lineNum">     599 </span>            :     }
<a name="600"><span class="lineNum">     600 </span><span class="lineCov">          5 : }</span></a>
<span class="lineNum">     601 </span><span class="lineCov">          5 : </span>
<span class="lineNum">     602 </span><span class="lineCov">          3 : float calcularIndiceDeGini(eph_h th, eph_i ti){</span>
<span class="lineNum">     603 </span>            :     return areaObservada(th,ti)/areaIgualdadTotal;
<span class="lineNum">     604 </span>            : }
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.13</a></td></tr>
  </table>
  <br>

</body>
</html>
